unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TMainForm = class(TForm)
    VstupSouborMemo: TMemo;
    Label1: TLabel;
    VystupSouborMemo: TMemo;
    Label2: TLabel;
    SpustTimer: TTimer;
    BackgroundImage: TImage;
    SpeedButton1: TSpeedButton;
    DelejButton: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ListBox1: TListBox;
    pocitadloLabel: TLabel;
    AktualSlovoLabel: TLabel;
    SpeedButton3: TSpeedButton;
    Label4: TLabel;
    SpeedButton4: TSpeedButton;
    procedure SpustTimerTimer(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure DelejButtonClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  VystupSoubor,            // vystupn soubor
  VstupSoubor,             // vstupni soubor
  SlovnikSoubor:textfile;  // soubor se slovnkem
  SlovoSlovniku: array[0..100000] of string;
  Pocitadlo:integer;
  polohaNextSlova:integer;
  dokonceno:boolean;        // dokonen celho zkoumn

implementation

uses SpustUnit, HelpUnit;

{$R *.DFM}
{$I+}

procedure TMainForm.SpustTimerTimer(Sender: TObject);
begin
 BezParamForm.Show;
  // killing timer
 Mainform.SpustTimer.Enabled:=false;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
 // konec  a uloen vsledku
 close;
 VystupSouborMemo.Lines.SaveToFile(BezParamForm.VystupEdit.Text);
end;

procedure TMainForm.DelejButtonClick(Sender: TObject);
begin

 pocitadlo:=0;

 // naten vstupnho souboru
 AssignFile(VstupSoubor,BezParamForm.VstupEdit.Text);
 Reset(VstupSoubor);

 // vytvoen vstupnho souboru
 AssignFile(VystupSoubor, BezParamForm.VystupEdit.Text);
 Rewrite(VystupSoubor);

 // zaven soubor
 closefile(vstupSoubor);
 closefile(vystupsoubor);

 // zkouka naten slov slovnku

 // slovnik soubor...
 AssignFile(SlovnikSoubor, 'dict.txt');
 Reset(SlovnikSoubor);

 // naten jednotlivch poloek slovnku, bohuel tak jak jsou
 // i s tm vzadu, take se podobn slovo hled dost tko...
 while not eof(slovnikSoubor) do
  begin
   ReadLn(SlovnikSoubor, slovoslovniku[pocitadlo]);
     listbox1.Items.Add(slovoslovniku[pocitadlo]);
     pocitadlolabel.Caption:=IntToStr(pocitadlo);
   pocitadlo:=pocitadlo+1;
  end;

 closefile(slovniksoubor);

end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
 var textVstupni:string;
     vyslstring:string;
     counterVystupu:integer;

begin
 // naten dalho slova tm, e se ze zkladnho textu
 // zkoumaj postupn znaky, dokud se nenaraz na mezeru
 // a vsledek se potom objev v AktualSlovoLabelu...
 // nefunguje vdy, vlastn skoro vbec...

 textvstupni:=VstupSouborMemo.Text;  // naten celho textu mema
 countervystupu:=1;                  // pozice v jednom slov

 if polohanextslova<Length(textvstupni) then // konec zkoumn, konec textu
  begin
  
   while (textvstupni[polohaNextSlova] <> ' ')
    do
     begin
      vyslstring:=vyslstring+' ';
      vyslString[countervystupu]:=textvstupni[polohanextSlova];
      polohanextslova:=polohanextSlova+1;         //  zvten hodnot
      counterVystupu:=counterVystupu+1;           //      o jednu
     end;

    polohanextSlova:=polohaNextSlova+1;

    AktualSlovoLabel.caption:=vyslstring;
  end;
end;


procedure TMainForm.FormCreate(Sender: TObject);
begin
 PolohaNextSlova:=1;
end;

procedure TMainForm.SpeedButton3Click(Sender: TObject);
 var counter:integer;
     slovo:string;
     bylo:boolean;
begin
 // zjitn, zda je slovo ve slovnku, pokud je, pidn
 // do mema, pokud ne pidn se znakem #... slovo se nat
 // z aktualSlovoLabelu

 slovo:=AktualSlovoLabel.Caption;  // naten aktulnho slova z labelu
 bylo:=false;

 for counter:= 1 to StrToInt(pocitadloLabel.caption) do
  begin
   if listbox1.Items[counter] = slovo then
    begin
     VystupSouborMemo.text:=vystupsoubormemo.Text+slovo+' '; // doplnit - je ve
     bylo:=true;                                             // slovnku
    end;
  end;

 if bylo = false then                                        // nen ve slovnku
   begin                                                     // doplnit s #
     vystupSouborMemo.Text:=vystupSouborMemo.Text+'#'+slovo+' ';
   end;

end;

procedure TMainForm.SpeedButton4Click(Sender: TObject);
begin
  // npovda je pro pochopen asi nejdleitj...
  HelpForm.ShowModal;
end;

end.
